=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2008-12-29 22:12:25 +0000
+++ drizzled/sql_parse.cc	2009-01-06 19:10:37 +0000
@@ -3848,16 +3848,13 @@
                            uint32_t max_char_length,
                            const char *param_for_err_msg)
 {
-#ifdef HAVE_CHARSET_utf8mb3
   /*
     We don't support non-BMP characters in identifiers at the moment,
     so they should be prohibited until such support is done.
     This is why we use the 3-byte utf8 to check well-formedness here.
   */
-  const CHARSET_INFO * const cs= &my_charset_utf8mb3_general_ci;
-#else
-  const CHARSET_INFO * const cs= system_charset_info;
-#endif
+  const CHARSET_INFO * const cs= &my_charset_utf8mb4_general_ci;
+
   int well_formed_error;
   uint32_t res= cs->cset->well_formed_len(cs, str->str, str->str + str->length,
                                       max_char_length, &well_formed_error);

=== modified file 'm4/character_sets.m4'
--- m4/character_sets.m4	2008-09-08 04:26:29 +0000
+++ m4/character_sets.m4	2009-01-06 19:10:37 +0000
@@ -28,7 +28,7 @@
 
 AC_MSG_CHECKING("character sets")
 
-CHARSETS="$default_charset utf8 utf8mb3"
+CHARSETS="$default_charset utf8"
 
 for cs in $CHARSETS
 do
@@ -40,11 +40,6 @@
       AC_DEFINE([USE_MB], 1, [Use multi-byte character routines])
       AC_DEFINE(USE_MB_IDENT, [1], [ ])
       ;;
-    utf8mb3)
-      AC_DEFINE(HAVE_CHARSET_utf8mb3, 1, [Define to enable ut8])
-      AC_DEFINE([USE_MB], 1, [Use multi-byte character routines])
-      AC_DEFINE(USE_MB_IDENT, 1)
-      ;;
     *)
       AC_MSG_ERROR([Charset '$cs' not available. (Available are: $CHARSETS_AVAILABLE).
       See the Installation chapter in the Reference Manual.])
@@ -69,27 +64,6 @@
       UTFC="UTFC1 UTFC2 UTFC3 UTFC4 UTFC5 UTFC6 UTFC7 UTFC8 UTFC9"
       default_charset_collations="$UTFC"
       ;;
-    utf8mb3)
-      default_charset_default_collation="utf8mb3_general_ci"
-      if test "$default_collation" = "utf8mb3_general_cs"; then
-        # For those who explicitly desire "utf8mb3_general_cs", support it,
-        # and then also set the CPP switch enabling that code.
-        UTFC="utf8mb3_general_cs"
-        AC_DEFINE([HAVE_UTF8_GENERAL_CS], [1], [certain Japanese customer])
-      else
-        define(UTFC1, utf8mb3_general_ci utf8mb3_bin)
-        define(UTFC2, utf8mb3_czech_ci utf8mb3_danish_ci)
-        define(UTFC3, utf8mb3_esperanto_ci utf8mb3_estonian_ci utf8mb3_icelandic_ci)
-        define(UTFC4, utf8mb3_latvian_ci utf8mb3_lithuanian_ci)
-        define(UTFC5, utf8mb3_persian_ci utf8mb3_polish_ci utf8mb3_romanian_ci)
-        define(UTFC6, utf8mb3_sinhala_ci utf8mb3_slovak_ci utf8mb3_slovenian_ci)
-        define(UTFC7, utf8mb3_spanish2_ci utf8mb3_spanish_ci)
-        define(UTFC8, utf8mb3_swedish_ci utf8mb3_turkish_ci)
-        define(UTFC9, utf8mb3_unicode_ci)
-        UTFC="UTFC1 UTFC2 UTFC3 UTFC4 UTFC5 UTFC6 UTFC7 UTFC8 UTFC9"
-      fi
-      default_charset_collations="$UTFC"
-      ;;
     *)
       AC_MSG_ERROR([Charset $cs not available. (Available are: $CHARSETS_AVAILABLE).
       See the Installation chapter in the Reference Manual.])

=== modified file 'mystrings/ctype-uca.cc'
--- mystrings/ctype-uca.cc	2008-12-06 19:42:46 +0000
+++ mystrings/ctype-uca.cc	2009-01-06 19:10:37 +0000
@@ -8064,7 +8064,7 @@
 }
 
 
-#if defined(HAVE_CHARSET_utf8mb3) || defined(HAVE_CHARSET_utf8mb4)
+#if defined(HAVE_CHARSET_utf8mb4)
 /*
   We consider bytes with code more than 127 as a letter.
   This garantees that word boundaries work fine with regular
@@ -8108,7 +8108,7 @@
   my_propagate_complex
 };
 
-#endif /* HAVE_CHARSET_utf8mb3 || HAVE_CHARSET_utf8mb4 */
+#endif /* HAVE_CHARSET_utf8mb4 */
 
 
 #ifdef HAVE_CHARSET_utf8mb4

=== modified file 'mystrings/ctype-utf8.cc'
--- mystrings/ctype-utf8.cc	2008-12-06 19:42:46 +0000
+++ mystrings/ctype-utf8.cc	2009-01-06 19:10:37 +0000
@@ -33,10 +33,6 @@
 #define MY_UTF8MB4_BIN        MY_UTF8MB4 "_bin"
 
 
-#if defined(HAVE_CHARSET_utf8mb3) || defined(HAVE_CHARSET_ucs2) || \
-    defined(HAVE_CHARSET_utf8mb4) || defined(HAVE_CHARSET_utf16) || \
-    defined(HAVE_CHARSET_utf32)
-
 #include <mystrings/my_uctype.h>
 
 static MY_UNICASE_INFO plane00[]={
@@ -1872,11 +1868,6 @@
   return (str != str_end ? 1 : 0);
 }
 
-#endif
-
-
-#ifdef HAVE_CHARSET_utf8mb4
-
 /*
   We consider bytes with code more than 127 as a letter.
   This garantees that word boundaries work fine with regular
@@ -2774,11 +2765,6 @@
   &my_collation_utf8mb4_bin_handler
 };
 
-#endif /* HAVE_CHARSET_utf8mb4 */
-
-
-#ifdef HAVE_CHARSET_utf8mb3
-
 /*
   We consider bytes with code more than 127 as a letter.
   This garantees that word boundaries work fine with regular
@@ -2855,1087 +2841,6 @@
 }
 
 
-int
-my_mb_wc_utf8mb3(const CHARSET_INFO * const, my_wc_t * pwc,
-                 const unsigned char *s, const unsigned char *e)
-{
-  unsigned char c;
-
-  if (s >= e)
-    return MY_CS_TOOSMALL;
-
-  c= s[0];
-  if (c < 0x80)
-  {
-    *pwc = c;
-    return 1;
-  }
-  else if (c < 0xc2)
-    return MY_CS_ILSEQ;
-  else if (c < 0xe0)
-  {
-    if (s+2 > e) /* We need 2 characters */
-      return MY_CS_TOOSMALL2;
-
-    if (!((s[1] ^ 0x80) < 0x40))
-      return MY_CS_ILSEQ;
-
-    *pwc = ((my_wc_t) (c & 0x1f) << 6) | (my_wc_t) (s[1] ^ 0x80);
-    return 2;
-  }
-  else if (c < 0xf0)
-  {
-    if (s+3 > e) /* We need 3 characters */
-      return MY_CS_TOOSMALL3;
-
-    if (!((s[1] ^ 0x80) < 0x40 && (s[2] ^ 0x80) < 0x40 &&
-          (c >= 0xe1 || s[1] >= 0xa0)))
-      return MY_CS_ILSEQ;
-
-    *pwc = ((my_wc_t) (c & 0x0f) << 12)   |
-           ((my_wc_t) (s[1] ^ 0x80) << 6) |
-            (my_wc_t) (s[2] ^ 0x80);
-
-    return 3;
-  }
-#ifdef UNICODE_32BIT
-  else if (c < 0xf8 && sizeof(my_wc_t)*8 >= 32)
-  {
-    if (s+4 > e) /* We need 4 characters */
-      return MY_CS_TOOSMALL4;
-
-    if (!((s[1] ^ 0x80) < 0x40 &&
-          (s[2] ^ 0x80) < 0x40 &&
-          (s[3] ^ 0x80) < 0x40 &&
-          (c >= 0xf1 || s[1] >= 0x90)))
-      return MY_CS_ILSEQ;
-
-    *pwc = ((my_wc_t) (c & 0x07) << 18)    |
-           ((my_wc_t) (s[1] ^ 0x80) << 12) |
-           ((my_wc_t) (s[2] ^ 0x80) << 6)  |
-            (my_wc_t) (s[3] ^ 0x80);
-
-    return 4;
-  }
-   else if (c < 0xfc && sizeof(my_wc_t)*8 >= 32)
-  {
-    if (s+5 >e) /* We need 5 characters */
-      return MY_CS_TOOSMALL5;
-
-    if (!((s[1] ^ 0x80) < 0x40 &&
-          (s[2] ^ 0x80) < 0x40 &&
-          (s[3] ^ 0x80) < 0x40 &&
-          (s[4] ^ 0x80) < 0x40 &&
-          (c >= 0xf9 || s[1] >= 0x88)))
-      return MY_CS_ILSEQ;
-
-    *pwc = ((my_wc_t) (c & 0x03) << 24) |
-           ((my_wc_t) (s[1] ^ 0x80) << 18) |
-           ((my_wc_t) (s[2] ^ 0x80) << 12) |
-           ((my_wc_t) (s[3] ^ 0x80) << 6) |
-            (my_wc_t) (s[4] ^ 0x80);
-    return 5;
-  }
-  else if (c < 0xfe && sizeof(my_wc_t)*8 >= 32)
-  {
-    if ( s+6 >e ) /* We need 6 characters */
-      return MY_CS_TOOSMALL6;
-
-    if (!((s[1] ^ 0x80) < 0x40   &&
-          (s[2] ^ 0x80) < 0x40   &&
-          (s[3] ^ 0x80) < 0x40   &&
-          (s[4] ^ 0x80) < 0x40   &&
-          (s[5] ^ 0x80) < 0x40   &&
-          (c >= 0xfd || s[1] >= 0x84)))
-      return MY_CS_ILSEQ;
-
-    *pwc = ((my_wc_t) (c & 0x01) << 30)
-      | ((my_wc_t) (s[1] ^ 0x80) << 24)
-      | ((my_wc_t) (s[2] ^ 0x80) << 18)
-      | ((my_wc_t) (s[3] ^ 0x80) << 12)
-      | ((my_wc_t) (s[4] ^ 0x80) << 6)
-      | (my_wc_t) (s[5] ^ 0x80);
-    return 6;
-  }
-#endif
-  return MY_CS_ILSEQ;
-}
-
-
-/*
-  The same as above, but without range check
-  for example, for a null-terminated string
-*/
-static int
-my_mb_wc_utf8mb3_no_range(const CHARSET_INFO * const,
-                          my_wc_t * pwc, const unsigned char *s)
-{
-  unsigned char c;
-
-  c= s[0];
-  if (c < 0x80)
-  {
-    *pwc = c;
-    return 1;
-  }
-
-  if (c < 0xc2)
-    return MY_CS_ILSEQ;
-
-  if (c < 0xe0)
-  {
-    if (!((s[1] ^ 0x80) < 0x40))
-      return MY_CS_ILSEQ;
-
-    *pwc = ((my_wc_t) (c & 0x1f) << 6) | (my_wc_t) (s[1] ^ 0x80);
-    return 2;
-  }
-
-  if (c < 0xf0)
-  {
-    if (!((s[1] ^ 0x80) < 0x40 &&
-          (s[2] ^ 0x80) < 0x40 &&
-          (c >= 0xe1 || s[1] >= 0xa0)))
-      return MY_CS_ILSEQ;
-
-    *pwc= ((my_wc_t) (c & 0x0f) << 12)   |
-          ((my_wc_t) (s[1] ^ 0x80) << 6) |
-           (my_wc_t) (s[2] ^ 0x80);
-
-    return 3;
-  }
-  return MY_CS_ILSEQ;
-}
-
-
-int my_wc_mb_utf8mb3(const CHARSET_INFO * const,
-                     my_wc_t wc, unsigned char *r, unsigned char *e)
-{
-  int count;
-
-  if (r >= e)
-    return MY_CS_TOOSMALL;
-
-  if (wc < 0x80)
-    count = 1;
-  else if (wc < 0x800)
-    count = 2;
-  else if (wc < 0x10000)
-    count = 3;
-#ifdef UNICODE_32BIT
-  else if (wc < 0x200000)
-    count = 4;
-  else if (wc < 0x4000000)
-    count = 5;
-  else if (wc <= 0x7fffffff)
-    count = 6;
-#endif
-    else return MY_CS_ILUNI;
-
-  /*
-    e is a character after the string r, not the last character of it.
-    Because of it (r+count > e), not (r+count-1 >e )
-   */
-  if ( r+count > e )
-    return MY_CS_TOOSMALLN(count);
-
-  switch (count) {
-    /* Fall through all cases!!! */
-#ifdef UNICODE_32BIT
-    case 6: r[5] = (unsigned char) (0x80 | (wc & 0x3f)); wc = wc >> 6; wc |= 0x4000000;
-    case 5: r[4] = (unsigned char) (0x80 | (wc & 0x3f)); wc = wc >> 6; wc |= 0x200000;
-    case 4: r[3] = (unsigned char) (0x80 | (wc & 0x3f)); wc = wc >> 6; wc |= 0x10000;
-#endif
-    case 3: r[2] = (unsigned char) (0x80 | (wc & 0x3f)); wc = wc >> 6; wc |= 0x800;
-    case 2: r[1] = (unsigned char) (0x80 | (wc & 0x3f)); wc = wc >> 6; wc |= 0xc0;
-    case 1: r[0] = (unsigned char) wc;
-  }
-  return count;
-}
-
-
-/*
-  The same as above, but without range check.
-*/
-static int
-my_wc_mb_utf8mb3_no_range(const CHARSET_INFO * const,
-                          my_wc_t wc, unsigned char *r)
-{
-  int count;
-
-  if (wc < 0x80)
-    count= 1;
-  else if (wc < 0x800)
-    count= 2;
-  else if (wc < 0x10000)
-    count= 3;
-  else
-    return MY_CS_ILUNI;
-
-  switch (count)
-  {
-    /* Fall through all cases!!! */
-    case 3: r[2]= (unsigned char) (0x80 | (wc & 0x3f)); wc= wc >> 6; wc |= 0x800;
-    case 2: r[1]= (unsigned char) (0x80 | (wc & 0x3f)); wc= wc >> 6; wc |= 0xc0;
-    case 1: r[0]= (unsigned char) wc;
-  }
-  return count;
-}
-
-
-size_t
-my_caseup_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
-                  char *dst, size_t dstlen)
-{
-  my_wc_t wc;
-  int srcres, dstres;
-  char *srcend= src + srclen, *dstend= dst + dstlen, *dst0= dst;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-  assert(src != dst || cs->caseup_multiply == 1);
-
-  while ((src < srcend) &&
-         (srcres= my_mb_wc_utf8mb3(cs, &wc,
-                                   (unsigned char *) src, (unsigned char*) srcend)) > 0)
-  {
-    int plane= (wc>>8) & 0xFF;
-    wc= uni_plane[plane] ? uni_plane[plane][wc & 0xFF].toupper : wc;
-    if ((dstres= my_wc_mb_utf8mb3(cs, wc, (unsigned char*) dst, (unsigned char*) dstend)) <= 0)
-      break;
-    src+= srcres;
-    dst+= dstres;
-  }
-  return (size_t) (dst - dst0);
-}
-
-
-extern "C"
-void my_hash_sort_utf8mb3(const CHARSET_INFO * const cs,
-                          const unsigned char *s, size_t slen,
-                          uint32_t *n1, uint32_t *n2)
-{
-  my_wc_t wc;
-  int res;
-  const unsigned char *e=s+slen;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-
-  /*
-    Remove end space. We have to do this to be able to compare
-    'A ' and 'A' as identical
-  */
-  while (e > s && e[-1] == ' ')
-    e--;
-
-  while ((s < e) && (res= my_mb_wc_utf8mb3(cs, &wc,
-                                    (const unsigned char *)s, (const unsigned char*)e)) > 0)
-  {
-    const int plane = (wc>>8) & 0xFF;
-    wc = uni_plane[plane] ? uni_plane[plane][wc & 0xFF].sort : wc;
-    n1[0]^= (((n1[0] & 63)+n2[0])*(wc & 0xFF))+ (n1[0] << 8);
-    n2[0]+=3;
-    n1[0]^= (((n1[0] & 63)+n2[0])*(wc >> 8))+ (n1[0] << 8);
-    n2[0]+=3;
-    s+=res;
-  }
-}
-
-
-size_t
-my_caseup_str_utf8mb3(const CHARSET_INFO * const cs, char *src)
-{
-  my_wc_t wc;
-  int srcres, dstres;
-  char *dst= src, *dst0= src;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-  assert(cs->caseup_multiply == 1);
-
-  while (*src &&
-         (srcres= my_mb_wc_utf8mb3_no_range(cs, &wc, (unsigned char *) src)) > 0)
-  {
-    const int plane= (wc>>8) & 0xFF;
-    wc= uni_plane[plane] ? uni_plane[plane][wc & 0xFF].toupper : wc;
-    if ((dstres= my_wc_mb_utf8mb3_no_range(cs, wc, (unsigned char*) dst)) <= 0)
-      break;
-    src+= srcres;
-    dst+= dstres;
-  }
-  *dst= '\0';
-  return (size_t) (dst - dst0);
-}
-
-
-size_t
-my_casedn_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
-                  char *dst, size_t dstlen)
-{
-  my_wc_t wc;
-  int srcres, dstres;
-  char *srcend= src + srclen, *dstend= dst + dstlen, *dst0= dst;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-  assert(src != dst || cs->casedn_multiply == 1);
-
-  while ((src < srcend) &&
-         (srcres= my_mb_wc_utf8mb3(cs, &wc,
-                                   (unsigned char*) src, (unsigned char*)srcend)) > 0)
-  {
-    int plane= (wc>>8) & 0xFF;
-    wc= uni_plane[plane] ? uni_plane[plane][wc & 0xFF].tolower : wc;
-    if ((dstres= my_wc_mb_utf8mb3(cs, wc, (unsigned char*) dst, (unsigned char*) dstend)) <= 0)
-      break;
-    src+= srcres;
-    dst+= dstres;
-  }
-  return (size_t) (dst - dst0);
-}
-
-
-size_t
-my_casedn_str_utf8mb3(const CHARSET_INFO * const cs, char *src)
-{
-  my_wc_t wc;
-  int srcres, dstres;
-  char *dst= src, *dst0= src;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-  assert(cs->casedn_multiply == 1);
-
-  while (*src &&
-         (srcres= my_mb_wc_utf8mb3_no_range(cs, &wc, (unsigned char *) src)) > 0)
-  {
-    int plane= (wc>>8) & 0xFF;
-    wc= uni_plane[plane] ? uni_plane[plane][wc & 0xFF].tolower : wc;
-    if ((dstres= my_wc_mb_utf8mb3_no_range(cs, wc, (unsigned char*) dst)) <= 0)
-      break;
-    src+= srcres;
-    dst+= dstres;
-  }
-
-  /*
-   In rare cases lower string can be shorter than
-   the original string, for example:
-
-   "U+0130 LATIN CAPITAL LETTER I WITH DOT ABOVE"
-   (which is 0xC4B0 in utf8, i.e. two bytes)
-
-   is converted into
-
-   "U+0069 LATIN SMALL LETTER I"
-   (which is 0x69 in utf8, i.e. one byte)
-
-   So, we need to put '\0' terminator after converting.
-  */
-
-  *dst= '\0';
-  return (size_t) (dst - dst0);
-}
-
-
-int
-my_strnncoll_utf8mb3(const CHARSET_INFO * const cs,
-                     const unsigned char *s, size_t slen,
-                     const unsigned char *t, size_t tlen,
-                     bool t_is_prefix)
-{
-  int s_res,t_res;
-  my_wc_t s_wc=0;
-  my_wc_t t_wc=0;
-  const unsigned char *se=s+slen;
-  const unsigned char *te=t+tlen;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-
-  while ( s < se && t < te )
-  {
-    int plane;
-    s_res= my_mb_wc_utf8mb3(cs,&s_wc, s, se);
-    t_res= my_mb_wc_utf8mb3(cs,&t_wc, t, te);
-
-    if ( s_res <= 0 || t_res <= 0 )
-    {
-      /* Incorrect string, compare bytewise */
-      return bincmp(s, se, t, te);
-    }
-
-    plane=(s_wc>>8) & 0xFF;
-    s_wc = uni_plane[plane] ? uni_plane[plane][s_wc & 0xFF].sort : s_wc;
-    plane=(t_wc>>8) & 0xFF;
-    t_wc = uni_plane[plane] ? uni_plane[plane][t_wc & 0xFF].sort : t_wc;
-    if ( s_wc != t_wc )
-    {
-      return  s_wc > t_wc ? 1 : -1;
-    }
-
-    s+=s_res;
-    t+=t_res;
-  }
-  return (int) (t_is_prefix ? t-te : ((se-s) - (te-t)));
-}
-
-
-/**
-  Compare strings, discarding end space
-
-  If one string is shorter as the other, then we space extend the other
-  so that the strings have equal length.
-
-  This will ensure that the following things hold:
-
-    "a"  == "a "
-    "a\0" < "a"
-    "a\0" < "a "
-
-  @param  cs        Character set pinter.
-  @param  a         First string to compare.
-  @param  a_length  Length of 'a'.
-  @param  b         Second string to compare.
-  @param  b_length  Length of 'b'.
-  @param  diff_if_only_endspace_difference
-                    Set to 1 if the strings should be regarded as different
-                    if they only difference in end space
-
-  @return Comparison result.
-    @retval Negative number, if a less than b.
-    @retval 0, if a is equal to b
-    @retval Positive number, if a > b
-*/
-
-int
-my_strnncollsp_utf8mb3(const CHARSET_INFO * const cs,
-                       const unsigned char *s, size_t slen,
-                       const unsigned char *t, size_t tlen,
-                       bool diff_if_only_endspace_difference)
-{
-  int s_res, t_res, res;
-  my_wc_t s_wc=0, t_wc=0;
-  const unsigned char *se= s+slen, *te= t+tlen;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-
-#ifndef VARCHAR_WITH_DIFF_ENDSPACE_ARE_DIFFERENT_FOR_UNIQUE
-  diff_if_only_endspace_difference= false;
-#endif
-
-  while ( s < se && t < te )
-  {
-    int plane;
-    s_res= my_mb_wc_utf8mb3(cs,&s_wc, s, se);
-    t_res= my_mb_wc_utf8mb3(cs,&t_wc, t, te);
-
-    if ( s_res <= 0 || t_res <= 0 )
-    {
-      /* Incorrect string, compare bytewise */
-      return bincmp(s, se, t, te);
-    }
-
-    plane=(s_wc>>8) & 0xFF;
-    s_wc = uni_plane[plane] ? uni_plane[plane][s_wc & 0xFF].sort : s_wc;
-    plane=(t_wc>>8) & 0xFF;
-    t_wc = uni_plane[plane] ? uni_plane[plane][t_wc & 0xFF].sort : t_wc;
-    if ( s_wc != t_wc )
-    {
-      return  s_wc > t_wc ? 1 : -1;
-    }
-
-    s+=s_res;
-    t+=t_res;
-  }
-
-  slen= (size_t) (se-s);
-  tlen= (size_t) (te-t);
-  res= 0;
-
-  if (slen != tlen)
-  {
-    int swap= 1;
-    if (diff_if_only_endspace_difference)
-      res= 1;                                   /* Assume 'a' is bigger */
-    if (slen < tlen)
-    {
-      slen= tlen;
-      s= t;
-      se= te;
-      swap= -1;
-      res= -res;
-    }
-    /*
-      This following loop uses the fact that in UTF-8
-      all multibyte characters are greater than space,
-      and all multibyte head characters are greater than
-      space. It means if we meet a character greater
-      than space, it always means that the longer string
-      is greater. So we can reuse the same loop from the
-      8bit version, without having to process full multibute
-      sequences.
-    */
-    for ( ; s < se; s++)
-    {
-      if (*s != ' ')
-	return (*s < ' ') ? -swap : swap;
-    }
-  }
-  return res;
-}
-
-
-/*
-  Compare 0-terminated UTF8 strings.
-
-  SYNOPSIS
-    my_strcasecmp_utf8mb3()
-    cs                  character set handler
-    s                   First 0-terminated string to compare
-    t                   Second 0-terminated string to compare
-
-  IMPLEMENTATION
-
-  RETURN
-    - negative number if s < t
-    - positive number if s > t
-    - 0 is the strings are equal
-*/
-
-int
-my_strcasecmp_utf8mb3(const CHARSET_INFO * const cs,
-                      const char *s, const char *t)
-{
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-  while (s[0] && t[0])
-  {
-    my_wc_t s_wc,t_wc;
-
-    if ((unsigned char) s[0] < 128)
-    {
-      /*
-        s[0] is between 0 and 127.
-        It represents a single byte character.
-        Convert it into weight according to collation.
-      */
-      s_wc= plane00[(unsigned char) s[0]].tolower;
-      s++;
-    }
-    else
-    {
-      int plane, res;
-
-      /*
-        Scan a multibyte character.
-
-        In the future it is worth to write a special version of my_utf8_uni()
-        for 0-terminated strings which will not take in account length. Now
-        we call the regular version of my_utf8_uni() with s+3 in the
-        last argument. s+3 is enough to scan any multibyte sequence.
-
-        Calling the regular version of my_utf8_uni is safe for 0-terminated
-        strings: we will never lose the end of the string:
-        If we have 0 character in the middle of a multibyte sequence,
-        then my_utf8_uni will always return a negative number, so the
-        loop with finish.
-      */
-
-      res= my_mb_wc_utf8mb3(cs, &s_wc, (const unsigned char*)s, (const unsigned char*) s + 3);
-
-      /*
-         In the case of wrong multibyte sequence we will
-         call strcmp() for byte-to-byte comparison.
-      */
-      if (res <= 0)
-        return strcmp(s, t);
-      s+= res;
-
-      /* Convert Unicode code into weight according to collation */
-      plane=(s_wc>>8) & 0xFF;
-      s_wc = uni_plane[plane] ? uni_plane[plane][s_wc & 0xFF].tolower : s_wc;
-    }
-
-
-    /* Do the same for the second string */
-
-    if ((unsigned char) t[0] < 128)
-    {
-      /* Convert single byte character into weight */
-      t_wc= plane00[(unsigned char) t[0]].tolower;
-      t++;
-    }
-    else
-    {
-      int plane;
-      int res= my_mb_wc_utf8mb3(cs, &t_wc,
-                                (const unsigned char*)t, (const unsigned char*) t + 3);
-      if (res <= 0)
-        return strcmp(s, t);
-      t+= res;
-
-      /* Convert code into weight */
-      plane=(t_wc>>8) & 0xFF;
-      t_wc = uni_plane[plane] ? uni_plane[plane][t_wc & 0xFF].tolower : t_wc;
-    }
-
-    /* Now we have two weights, let's compare them */
-    if ( s_wc != t_wc )
-      return  ((int) s_wc) - ((int) t_wc);
-  }
-  return ((int)(unsigned char)s[0]) - ((int) (unsigned char) t[0]);
-}
-
-
-int
-my_wildcmp_utf8mb3(const CHARSET_INFO * const cs,
-		   const char *str,const char *str_end,
-		   const char *wildstr,const char *wildend,
-		   int escape, int w_one, int w_many)
-{
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-  return my_wildcmp_unicode(cs,str,str_end,wildstr,wildend,
-                            escape,w_one,w_many,uni_plane);
-}
-
-
-size_t
-my_strnxfrmlen_utf8mb3(const CHARSET_INFO * const, size_t len)
-{
-  return (len * 2 + 2) / 3;
-}
-
-
-size_t
-my_strnxfrm_utf8mb3(const CHARSET_INFO * const cs,
-                    unsigned char *dst, size_t dstlen, uint32_t nweights,
-                    const unsigned char *src, size_t srclen, uint32_t flags)
-{
-  my_wc_t wc;
-  int res;
-  int plane;
-  unsigned char *dst0= dst;
-  unsigned char *de= dst + dstlen;
-  unsigned char *de_beg= de - 1;
-  const unsigned char *se = src + srclen;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-
-  for (; dst < de_beg && nweights; nweights--)
-  {
-    if ((res= my_mb_wc_utf8mb3(cs,&wc, src, se)) <= 0)
-      break;
-    src+=res;
-
-    plane=(wc>>8) & 0xFF;
-    wc = uni_plane[plane] ? uni_plane[plane][wc & 0xFF].sort : wc;
-
-    *dst++= (unsigned char)(wc >> 8);
-    *dst++= (unsigned char)(wc & 0xFF);
-
-  }
-
-  if (dst < de && nweights && (flags & MY_STRXFRM_PAD_WITH_SPACE))
-  {
-    /* Fill the tail with keys for space character */
-    for (; dst < de_beg && nweights; nweights--)
-    {
-      *dst++= 0x00;
-      *dst++= 0x20;
-    }
-
-    if (dst < de)  /* Clear the last byte, if "dstlen" was an odd number */
-      *dst++= 0x00;
-  }
-  my_strxfrm_desc_and_reverse(dst0, dst, flags, 0);
-  return dst - dst0;
-}
-
-
-size_t
-my_strnxfrm_utf8mb3_bin(const CHARSET_INFO * const cs,
-                        unsigned char *dst, size_t dstlen, uint32_t nweights,
-                        const unsigned char *src, size_t srclen, uint32_t flags)
-{
-  my_wc_t wc;
-  int res;
-  unsigned char *dst0= dst;
-  unsigned char *de= dst + dstlen;
-  unsigned char *de_beg= de - 1;
-  const unsigned char *se= src + srclen;
-
-  for (; dst < de_beg && nweights; nweights--)
-  {
-    if ((res= my_mb_wc_utf8mb3(cs, &wc, src, se)) <= 0)
-      break;
-    src+=res;
-
-    *dst++= (unsigned char)(wc >> 8);
-    *dst++= (unsigned char)(wc & 0xFF);
-  }
-
-  if (dst < de && nweights && (flags & MY_STRXFRM_PAD_WITH_SPACE))
-  {
-    /* Fill the tail with keys for space character */
-    for (; dst < de_beg && nweights; nweights--)
-    {
-      *dst++= 0x00;
-      *dst++= 0x20;
-    }
-
-    if (dst < de)  /* Clear the last byte, if "dstlen" was an odd number */
-      *dst++= 0x00;
-  }
-  my_strxfrm_desc_and_reverse(dst0, dst, flags, 0);
-  return dst - dst0;
-}
-
-
-unsigned int
-my_ismbchar_utf8mb3(const CHARSET_INFO * const cs, const char *b, const char *e)
-{
-  my_wc_t wc;
-  int  res= my_mb_wc_utf8mb3(cs, &wc, (const unsigned char*) b, (const unsigned char*) e);
-  return (res>1) ? res : 0;
-}
-
-
-unsigned int
-my_mbcharlen_utf8mb3(const CHARSET_INFO * const, uint32_t c)
-{
-  if (c < 0x80)
-    return 1;
-  else if (c < 0xc2)
-    return 0; /* Illegal mb head */
-  else if (c < 0xe0)
-    return 2;
-  else if (c < 0xf0)
-    return 3;
-#ifdef UNICODE_32BIT
-  else if (c < 0xf8)
-    return 4;
-  else if (c < 0xfc)
-    return 5;
-  else if (c < 0xfe)
-    return 6;
-#endif
-  return 0; /* Illegal mb head */;
-}
-
-
-static MY_COLLATION_HANDLER my_collation_utf8mb3_general_ci_handler =
-{
-    NULL,               /* init */
-    my_strnncoll_utf8mb3,
-    my_strnncollsp_utf8mb3,
-    my_strnxfrm_utf8mb3,
-    my_strnxfrmlen_utf8mb3,
-    my_like_range_mb,
-    my_wildcmp_utf8mb3,
-    my_strcasecmp_utf8mb3,
-    my_instr_mb,
-    my_hash_sort_utf8mb3,
-    my_propagate_complex
-};
-
-
-static MY_COLLATION_HANDLER my_collation_utf8mb3_bin_handler =
-{
-    NULL,		/* init */
-    my_strnncoll_mb_bin,
-    my_strnncollsp_mb_bin,
-    my_strnxfrm_utf8mb3_bin,
-    my_strnxfrmlen_utf8mb3,
-    my_like_range_mb,
-    my_wildcmp_mb_bin,
-    my_strcasecmp_mb_bin,
-    my_instr_mb,
-    my_hash_sort_mb_bin,
-    my_propagate_simple
-};
-
-
-MY_CHARSET_HANDLER my_charset_utf8mb3_handler=
-{
-    NULL,               /* init */
-    my_ismbchar_utf8mb3,
-    my_mbcharlen_utf8mb3,
-    my_numchars_mb,
-    my_charpos_mb,
-    my_well_formed_len_mb,
-    my_lengthsp_8bit,
-    my_numcells_mb,
-    my_mb_wc_utf8mb3,
-    my_wc_mb_utf8mb3,
-    my_mb_ctype_mb,
-    my_caseup_str_utf8mb3,
-    my_casedn_str_utf8mb3,
-    my_caseup_utf8mb3,
-    my_casedn_utf8mb3,
-    my_snprintf_8bit,
-    my_long10_to_str_8bit,
-    my_int64_t10_to_str_8bit,
-    my_fill_8bit,
-    my_strntol_8bit,
-    my_strntoul_8bit,
-    my_strntoll_8bit,
-    my_strntoull_8bit,
-    my_strntod_8bit,
-    my_strtoll10_8bit,
-    my_strntoull10rnd_8bit,
-    my_scan_8bit
-};
-
-
-
-CHARSET_INFO my_charset_utf8mb3_general_ci=
-{
-    33,0,0,             /* number       */
-    MY_CS_COMPILED|MY_CS_PRIMARY|MY_CS_STRNXFRM|MY_CS_UNICODE,  /* state  */
-    MY_UTF8MB3,         /* cs name      */
-    MY_UTF8MB3_GENERAL_CI,/* name       */
-    "UTF-8 Unicode",    /* comment      */
-    NULL,               /* tailoring    */
-    ctype_utf8,         /* ctype        */
-    to_lower_utf8,      /* to_lower     */
-    to_upper_utf8,      /* to_upper     */
-    to_upper_utf8,      /* sort_order   */
-    NULL,               /* contractions */
-    NULL,               /* sort_order_big*/
-    NULL,               /* tab_to_uni   */
-    NULL,               /* tab_from_uni */
-    my_unicase_default, /* caseinfo     */
-    NULL,               /* state_map    */
-    NULL,               /* ident_map    */
-    1,                  /* strxfrm_multiply */
-    1,                  /* caseup_multiply  */
-    1,                  /* casedn_multiply  */
-    1,                  /* mbminlen     */
-    3,                  /* mbmaxlen     */
-    0,                  /* min_sort_char */
-    0xFFFF,             /* max_sort_char */
-    ' ',                /* pad char      */
-    0,                  /* escape_with_backslash_is_dangerous */
-    1,                  /* levels_for_compare */
-    1,                  /* levels_for_order   */
-    &my_charset_utf8mb3_handler,
-    &my_collation_utf8mb3_general_ci_handler
-};
-
-
-CHARSET_INFO my_charset_utf8mb3_bin=
-{
-    83,0,0,             /* number       */
-    MY_CS_COMPILED|MY_CS_BINSORT|MY_CS_UNICODE, /* state  */
-    MY_UTF8MB3,         /* cs name      */
-    MY_UTF8MB3_BIN,     /* name         */
-    "UTF-8 Unicode",    /* comment      */
-    NULL,               /* tailoring    */
-    ctype_utf8,         /* ctype        */
-    to_lower_utf8,      /* to_lower     */
-    to_upper_utf8,      /* to_upper     */
-    NULL,               /* sort_order   */
-    NULL,               /* contractions */
-    NULL,               /* sort_order_big*/
-    NULL,               /* tab_to_uni   */
-    NULL,               /* tab_from_uni */
-    my_unicase_default, /* caseinfo     */
-    NULL,               /* state_map    */
-    NULL,               /* ident_map    */
-    1,                  /* strxfrm_multiply */
-    1,                  /* caseup_multiply  */
-    1,                  /* casedn_multiply  */
-    1,                  /* mbminlen     */
-    3,                  /* mbmaxlen     */
-    0,                  /* min_sort_char */
-    0xFFFF,             /* max_sort_char */
-    ' ',                /* pad char      */
-    0,                  /* escape_with_backslash_is_dangerous */
-    1,                  /* levels_for_compare */
-    1,                  /* levels_for_order   */
-    &my_charset_utf8mb3_handler,
-    &my_collation_utf8mb3_bin_handler
-};
-
-#ifdef HAVE_UTF8_GENERAL_CS
-
-#define MY_UTF8MB3_GENERAL_CS MY_UTF8MB3 "_general_cs"
-
-/*
- * These functions bacically do the same as their original, except
- * that they return 0 only when two comparing unicode strings are
- * strictly the same in case-sensitive way.  See "save_diff" local
- * variable to what they actually do.
- */
-
-int
-my_strnncoll_utf8mb3_cs(CHARSET_INFO *cs,
-                        const unsigned char *s, size_t slen,
-                        const unsigned char *t, size_t tlen,
-                        bool t_is_prefix)
-{
-  int s_res,t_res;
-  my_wc_t s_wc,t_wc;
-  const unsigned char *se=s+slen;
-  const unsigned char *te=t+tlen;
-  int save_diff = 0;
-  int diff;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-
-  while ( s < se && t < te )
-  {
-    int plane;
-    s_res= my_mb_wc_utf8mb3(cs, &s_wc, s, se);
-    t_res= my_mb_wc_utf8mb3(cs, &t_wc, t, te);
-
-    if ( s_res <= 0 || t_res <= 0 )
-
-    {
-      /* Incorrect string, compare by char value */
-      return ((int)s[0]-(int)t[0]);
-    }
-
-    if ( save_diff == 0 )
-    {
-      save_diff = ((int)s_wc) - ((int)t_wc);
-    }
-    plane=(s_wc>>8) & 0xFF;
-    s_wc = uni_plane[plane] ? uni_plane[plane][s_wc & 0xFF].sort : s_wc;
-    plane=(t_wc>>8) & 0xFF;
-    t_wc = uni_plane[plane] ? uni_plane[plane][t_wc & 0xFF].sort : t_wc;
-    if ( s_wc != t_wc )
-    {
-      return  ((int) s_wc) - ((int) t_wc);
-    }
-
-    s+=s_res;
-    t+=t_res;
-  }
-  diff = ( (se-s) - (te-t) );
-  return t_is_prefix ? t-te : ((diff == 0) ? save_diff : diff);
-}
-
-int
-my_strnncollsp_utf8mb3_cs(CHARSET_INFO *cs,
-                          const unsigned char *s, size_t slen,
-                          const unsigned char *t, size_t tlen,
-                          bool diff_if_only_endspace_difference)
-{
-  int s_res, t_res, res;
-  my_wc_t s_wc, t_wc;
-  const unsigned char *se= s + slen;
-  const unsigned char *te= t + tlen;
-  int save_diff= 0;
-  MY_UNICASE_INFO **uni_plane= cs->caseinfo;
-
-#ifndef VARCHAR_WITH_DIFF_ENDSPACE_ARE_DIFFERENT_FOR_UNIQUE
-  diff_if_only_endspace_difference= false;
-#endif
-
-  while ( s < se && t < te )
-  {
-    int plane;
-    s_res= my_mb_wc_utf8mb3(cs, &s_wc, s, se);
-    t_res= my_mb_wc_utf8mb3(cs, &t_wc, t, te);
-
-    if ( s_res <= 0 || t_res <= 0 )
-    {
-      /* Incorrect string, compare by char value */
-      return ((int)s[0]-(int)t[0]);
-    }
-
-    if ( save_diff == 0 )
-    {
-      save_diff = ((int)s_wc) - ((int)t_wc);
-    }
-    plane=(s_wc>>8) & 0xFF;
-    s_wc = uni_plane[plane] ? uni_plane[plane][s_wc & 0xFF].sort : s_wc;
-    plane=(t_wc>>8) & 0xFF;
-    t_wc = uni_plane[plane] ? uni_plane[plane][t_wc & 0xFF].sort : t_wc;
-    if ( s_wc != t_wc )
-    {
-      return  ((int) s_wc) - ((int) t_wc);
-    }
-
-    s+=s_res;
-    t+=t_res;
-  }
-
-  slen= se-s;
-  tlen= te-t;
-  res= 0;
-
-  if (slen != tlen)
-  {
-    int swap= 1;
-    if (diff_if_only_endspace_difference)
-      res= 1;                                   /* Assume 'a' is bigger */
-    if (slen < tlen)
-    {
-      slen= tlen;
-      s= t;
-      se= te;
-      swap= -1;
-      res= -res;
-    }
-    /*
-      This following loop uses the fact that in UTF-8
-      all multibyte characters are greater than space,
-      and all multibyte head characters are greater than
-      space. It means if we meet a character greater
-      than space, it always means that the longer string
-      is greater. So we can reuse the same loop from the
-      8bit version, without having to process full multibute
-      sequences.
-    */
-    for ( ; s < se; s++)
-    {
-      if (*s != (unsigned char) ' ')
-        return (*s < (unsigned char) ' ') ? -swap : swap;
-    }
-  }
-  return save_diff;
-}
-
-
-static MY_COLLATION_HANDLER my_collation_utf8mb3_general_cs_handler =
-{
-    NULL,		/* init */
-    my_strnncoll_utf8mb3_cs,
-    my_strnncollsp_utf8mb3_cs,
-    my_strnxfrm_utf8mb3,
-    my_strnxfrmlen_utf8mb3,
-    my_like_range_simple,
-    my_wildcmp_mb,
-    my_strcasecmp_utf8mb3,
-    my_instr_mb,
-    my_hash_sort_utf8mb3,
-    my_propagate_simple
-};
-
-
-CHARSET_INFO my_charset_utf8mb3_general_cs=
-{
-    254,0,0,		/* number       */
-    MY_CS_COMPILED|MY_CS_UNICODE,	/* state  */
-    MY_UTF8MB3,	        /* cs name      */
-    MY_UTF8MB3_GENERAL_CS,/* name       */
-    "UTF-8 Unicode",    /* comment      */
-    NULL,		/* tailoring    */
-    ctype_utf8,		/* ctype        */
-    to_lower_utf8,	/* to_lower     */
-    to_upper_utf8,	/* to_upper     */
-    to_upper_utf8,	/* sort_order   */
-    NULL,		/* contractions */
-    NULL,		/* sort_order_big*/
-    NULL,		/* tab_to_uni   */
-    NULL,		/* tab_from_uni */
-    my_unicase_default, /* caseinfo     */
-    NULL,		/* state_map    */
-    NULL,		/* ident_map    */
-    1,			/* strxfrm_multiply */
-    1,                  /* caseup_multiply  */
-    1,                  /* casedn_multiply  */
-    1,			/* mbminlen     */
-    3,			/* mbmaxlen     */
-    0,			/* min_sort_char */
-    255,		/* max_sort_char */
-    ' ',                /* pad char      */
-    0,                  /* escape_with_backslash_is_dangerous */
-    1,                  /* levels_for_compare */
-    1,                  /* levels_for_order   */
-    &my_charset_utf8mb3_handler,
-    &my_collation_utf8mb3_general_cs_handler
-};
-#endif	/* Cybozu Hack */
-
-
 /*
   File system encoding components:
 
@@ -5153,15 +4058,15 @@
 static MY_COLLATION_HANDLER my_collation_filename_handler =
 {
     NULL,               /* init */
-    my_strnncoll_utf8mb3,
-    my_strnncollsp_utf8mb3,
-    my_strnxfrm_utf8mb3,
-    my_strnxfrmlen_utf8mb3,
+    my_strnncoll_utf8mb4,
+    my_strnncollsp_utf8mb4,
+    my_strnxfrm_utf8mb4,
+    my_strnxfrmlen_utf8mb4,
     my_like_range_mb,
-    my_wildcmp_utf8mb3,
-    my_strcasecmp_utf8mb3,
+    my_wildcmp_utf8mb4,
+    my_strcasecmp_utf8mb4,
     my_instr_mb,
-    my_hash_sort_utf8mb3,
+    my_hash_sort_utf8mb4,
     my_propagate_complex
 };
 
@@ -5169,8 +4074,8 @@
 static MY_CHARSET_HANDLER my_charset_filename_handler=
 {
     NULL,               /* init */
-    my_ismbchar_utf8mb3,
-    my_mbcharlen_utf8mb3,
+    my_ismbchar_utf8mb4,
+    my_mbcharlen_utf8mb4,
     my_numchars_mb,
     my_charpos_mb,
     my_well_formed_len_mb,
@@ -5179,10 +4084,10 @@
     my_mb_wc_filename,
     my_wc_mb_filename,
     my_mb_ctype_mb,
-    my_caseup_str_utf8mb3,
-    my_casedn_str_utf8mb3,
-    my_caseup_utf8mb3,
-    my_casedn_utf8mb3,
+    my_caseup_str_utf8mb4,
+    my_casedn_str_utf8mb4,
+    my_caseup_utf8mb4,
+    my_casedn_utf8mb4,
     my_snprintf_8bit,
     my_long10_to_str_8bit,
     my_int64_t10_to_str_8bit,
@@ -5283,5 +4188,3 @@
 }
 
 #endif
-
-#endif /* HAVE_CHARSET_utf8mb3 */

=== modified file 'tests/r/mysqldump-max.result'
--- tests/r/mysqldump-max.result	2008-12-06 22:41:03 +0000
+++ tests/r/mysqldump-max.result	2009-01-06 19:10:37 +0000
@@ -70,6 +70,51 @@
 CREATE DATABASE /*!32312 IF NOT EXISTS*/ `test` /*!40100 DEFAULT CHARACTER SET utf8 */;
 
 USE `test`;
+DROP TABLE IF EXISTS `t1`;
+CREATE TABLE `t1` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=InnoDB;
+
+/*!40000 ALTER TABLE `t1` DISABLE KEYS */;
+INSERT  IGNORE INTO `t1` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t1` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t2`;
+CREATE TABLE `t2` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=MyISAM;
+
+/*!40000 ALTER TABLE `t2` DISABLE KEYS */;
+INSERT  DELAYED IGNORE INTO `t2` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t2` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t3`;
+CREATE TABLE `t3` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=MEMORY;
+
+/*!40000 ALTER TABLE `t3` DISABLE KEYS */;
+INSERT  DELAYED IGNORE INTO `t3` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t3` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t4`;
+CREATE TABLE `t4` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=MEMORY;
+
+/*!40000 ALTER TABLE `t4` DISABLE KEYS */;
+INSERT  DELAYED IGNORE INTO `t4` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t4` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t6`;
+CREATE TABLE `t6` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=InnoDB;
+
+/*!40000 ALTER TABLE `t6` DISABLE KEYS */;
+INSERT  IGNORE INTO `t6` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t6` ENABLE KEYS */;
 /*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
 /*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
 /*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
@@ -78,6 +123,51 @@
 CREATE DATABASE /*!32312 IF NOT EXISTS*/ `test` /*!40100 DEFAULT CHARACTER SET utf8 */;
 
 USE `test`;
+DROP TABLE IF EXISTS `t1`;
+CREATE TABLE `t1` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=InnoDB;
+
+/*!40000 ALTER TABLE `t1` DISABLE KEYS */;
+INSERT INTO `t1` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t1` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t2`;
+CREATE TABLE `t2` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=MyISAM;
+
+/*!40000 ALTER TABLE `t2` DISABLE KEYS */;
+INSERT  DELAYED INTO `t2` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t2` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t3`;
+CREATE TABLE `t3` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=MEMORY;
+
+/*!40000 ALTER TABLE `t3` DISABLE KEYS */;
+INSERT  DELAYED INTO `t3` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t3` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t4`;
+CREATE TABLE `t4` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=MEMORY;
+
+/*!40000 ALTER TABLE `t4` DISABLE KEYS */;
+INSERT  DELAYED INTO `t4` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t4` ENABLE KEYS */;
+DROP TABLE IF EXISTS `t6`;
+CREATE TABLE `t6` (
+  `id` int,
+  `name` varchar(32)
+) ENGINE=InnoDB;
+
+/*!40000 ALTER TABLE `t6` DISABLE KEYS */;
+INSERT INTO `t6` VALUES ('1','first value'),('2','first value'),('3','first value'),('4','first value'),('5','first value');
+/*!40000 ALTER TABLE `t6` ENABLE KEYS */;
 /*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
 /*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
 drop table t1;

